
	.export		_nmi_main

	.import		_nsd_main
	.import		ppubuf_flush

	.include	"zeropage.inc"
	.include	"nes.inc"

	.include	"..\..\include\nsd.inc"

;===============================================================
;		NMI	main routine
;===============================================================
.proc	_nmi_main

	;register push
	pha
	tya
	pha
	txa
	pha

	;Call ppu
	lda	#1
	sta	VBLANK_FLAG

	inc	tickcount
	bne	@s
	inc	tickcount+1

@s:	jsr	ppubuf_flush

	; reset the video counter
	lda	#$20
	sta	PPU_VRAM_ADDR2
	lda	#$00
	sta	PPU_VRAM_ADDR2

	; reset scrolling
	sta	PPU_VRAM_ADDR1
	sta	PPU_VRAM_ADDR1

	;Call sound driver main routine
	jsr	_nsd_main

	;register pop
	pla
	tax
	pla
	tay
	pla

	rti
.endproc
