
	.export	_read_key
	.export	_inkey

	.include	"zeropage.inc"
	.include	"nes.inc"

	.include	"..\..\include\nsd.inc"

;--------------------------------------
;L[ǂݍݗp̒`
;
;	JOY_A		$80
;	JOY_B		$40
;	JOY_Select	$20
;	JOY_Start	$10
;	JOY_Up		$08
;	JOY_Down	$04
;	JOY_Right	$02
;	JOY_Left	$01
;
;===============================================================
;		Key read
;---------------------------------------------------------------
;  << Input >>
;	A	0:Pad 1 / 1:Pad 2
;  << Output >>
;	A	Key
;  <<  >>
;===============================================================
.code
.proc	_read_key

	and	#$01
	tay

	lda	#1
	sta	APU_PAD1,y
	lda	#0
	sta	APU_PAD1,y

	; Read joystick
	ldx	#8
@Loop:	lda	APU_PAD1,y
	ror	a
	rol	tmp1
	dex
	bne	@Loop

	lda	tmp1

	rts
.endproc

;===============================================================
;		Key read with old key check
;---------------------------------------------------------------
;  << Input >>
;	A	0:Pad 1 / 1:Pad 2
;  << Output >>
;	A	Key
;  <<  >>
;===============================================================
.data
old_key:	.byte	-1

.code
.proc	_inkey

	jsr	_read_key

	cmp	old_key
	beq	@L
	sta	old_key
	jmp	@E
@L:	lda	#0
@E:	rts
.endproc


