
	.export	_play_bgm
	.export	_stop_bgm
	.export	_play_se
	.export	_stop_se

	.include	"..\..\include\nsd.inc"

	.import	_MUS_BGM0
	.import	_MUS_SE0
	.import	_MUS_SE1

.rodata

bgm:	.word	_MUS_BGM0

se:	.word	_MUS_SE0
	.word	_MUS_SE1

;===============================================================
;		Music Play
;---------------------------------------------------------------
;  << Input >>
;	A	Music number
;  << Output >>
;		None
;  <<  >>
;===============================================================
.code
.proc	_play_bgm
	asl	a
	tay
	lda	bgm,y
	ldx	bgm + 1,y
	jmp	_nsd_play_bgm
.endproc

;===============================================================
;		Stop Music
;---------------------------------------------------------------
;  << Input >>
;		None
;  << Output >>
;		None
;  <<  >>
;===============================================================
.proc	_stop_bgm
	jmp	_nsd_stop_bgm
.endproc

;===============================================================
;		SE Play
;---------------------------------------------------------------
;  << Input >>
;	A	Music number
;  << Output >>
;		None
;  <<  >>
;===============================================================
.code
.proc	_play_se
	asl	a
	tay
	lda	se,y
	ldx	se + 1,y
	jmp	_nsd_play_se
.endproc

;===============================================================
;		SE Music
;---------------------------------------------------------------
;  << Input >>
;		None
;  << Output >>
;		None
;  <<  >>
;===============================================================
.proc	_stop_se
	jmp	_nsd_stop_se
.endproc
