
	.import	ppubuf_put
	.import	_waitvblank
	.import	_sprite_dma

	.export	_title_draw

	.include	"zeropage.inc"
	.include	"nes.inc"

	.include	"..\..\include\nsd.inc"

.proc	_title_draw

	lda	#%10110011
	sta	PPU_CTRL1

	lda	#%00000110
	sta	PPU_CTRL2

	lda	#<(title_name)
	sta	ptr1
	lda	#>(title_name)
	sta	ptr1 + 1

	lda	#$00
	sta	tmp1
	lda	#$20
	sta	tmp1 + 1

	ldy	#0


@L0:	ldy	tmp1
	lda	(ptr1),y
	ldx	tmp1
	ldy	tmp1 + 1
	jsr	ppubuf_put
	ldx	tmp1
	inx
	stx	tmp1
	bne	@L0
	ldx	tmp1 + 1
	inx
	stx	tmp1 + 1
	ldx	ptr1 + 1
	inx
	stx	ptr1 + 1

@L1:	ldy	tmp1
	lda	(ptr1),y
	ldx	tmp1
	ldy	tmp1 + 1
	jsr	ppubuf_put
	ldx	tmp1
	inx
	stx	tmp1
	bne	@L1
	ldx	tmp1 + 1
	inx
	stx	tmp1 + 1
	ldx	ptr1 + 1
	inx
	stx	ptr1 + 1

@L2:	ldy	tmp1
	lda	(ptr1),y
	ldx	tmp1
	ldy	tmp1 + 1
	jsr	ppubuf_put
	ldx	tmp1
	inx
	stx	tmp1
	bne	@L2
	ldx	tmp1 + 1
	inx
	stx	tmp1 + 1
	ldx	ptr1 + 1
	inx
	stx	ptr1 + 1

@L3:	ldy	tmp1
	lda	(ptr1),y
	ldx	tmp1
	ldy	tmp1 + 1
	jsr	ppubuf_put
	ldx	tmp1
	inx
	stx	tmp1
	bne	@L3


	;PPŨOobt@ 0 ɂȂ܂ő҂BE
@L4:	ldy	ringcount
	bne	@L4

;	;XvCg
;	lda	#<(sprite_table)
;	sta	ptr1
;	lda	#>(sprite_table)
;	sta	ptr1 + 1
;
;	jsr	_waitvblank
;
;	ldy	$0
;	sty	PPU_SPR_ADDR
;
;@L5:	lda	(ptr1),y
;	sta	PPU_SPR_IO
;	iny
;	cpy	#4*14
;	bne	@L5
;

	lda	#<(sprite_table)
	ldx	#>(sprite_table)
	jsr	_sprite_dma

	lda	#%10110000
	sta	PPU_CTRL1

	lda	#%00011110
	sta	PPU_CTRL2

	rts
.endproc


.rodata

sprite_table:	;y   n    a    x
	.byte	$ef, $00, $00, $00	;0E
	.byte	$ef, $00, $00, $00	;0F
	.byte	$46, $00, $02, $0F	;00
	.byte	$56, $02, $02, $0F	;01
	.byte	$44, $04, $02, $17	;02
	.byte	$54, $06, $02, $17	;03
	.byte	$42, $08, $02, $1F	;04
	.byte	$52, $0A, $02, $1F	;05
	.byte	$40, $0C, $02, $27	;06
	.byte	$50, $0E, $02, $27	;07
	.byte	$3E, $10, $02, $2F	;08
	.byte	$4E, $12, $02, $2F	;09
	.byte	$3C, $14, $02, $37	;0A
	.byte	$4C, $16, $02, $37	;0B
	.byte	$3A, $18, $02, $3F	;0C
	.byte	$4A, $1A, $02, $3F	;0D

	.byte	$ef, $00, $00, $00	;10
	.byte	$ef, $00, $00, $00	;11
	.byte	$ef, $00, $00, $00	;12
	.byte	$ef, $00, $00, $00	;13
	.byte	$ef, $00, $00, $00	;14
	.byte	$ef, $00, $00, $00	;15
	.byte	$ef, $00, $00, $00	;16
	.byte	$ef, $00, $00, $00	;17
	.byte	$ef, $00, $00, $00	;18
	.byte	$ef, $00, $00, $00	;19
	.byte	$ef, $00, $00, $00	;1A
	.byte	$ef, $00, $00, $00	;1B
	.byte	$ef, $00, $00, $00	;1C
	.byte	$ef, $00, $00, $00	;1D
	.byte	$ef, $00, $00, $00	;1E
	.byte	$ef, $00, $00, $00	;1F

	.byte	$ef, $00, $00, $00	;20
	.byte	$ef, $00, $00, $00	;21
	.byte	$ef, $00, $00, $00	;22
	.byte	$ef, $00, $00, $00	;23
	.byte	$ef, $00, $00, $00	;24
	.byte	$ef, $00, $00, $00	;25
	.byte	$ef, $00, $00, $00	;26
	.byte	$ef, $00, $00, $00	;27
	.byte	$ef, $00, $00, $00	;28
	.byte	$ef, $00, $00, $00	;29
	.byte	$ef, $00, $00, $00	;2A
	.byte	$ef, $00, $00, $00	;2B
	.byte	$ef, $00, $00, $00	;2C
	.byte	$ef, $00, $00, $00	;2D
	.byte	$ef, $00, $00, $00	;2E
	.byte	$ef, $00, $00, $00	;2F

	.byte	$ef, $00, $00, $00	;30
	.byte	$ef, $00, $00, $00	;31
	.byte	$ef, $00, $00, $00	;32
	.byte	$ef, $00, $00, $00	;33
	.byte	$ef, $00, $00, $00	;34
	.byte	$ef, $00, $00, $00	;35
	.byte	$ef, $00, $00, $00	;36
	.byte	$ef, $00, $00, $00	;37
	.byte	$ef, $00, $00, $00	;38
	.byte	$ef, $00, $00, $00	;39
	.byte	$ef, $00, $00, $00	;3A
	.byte	$ef, $00, $00, $00	;3B
	.byte	$ef, $00, $00, $00	;3C
	.byte	$ef, $00, $00, $00	;3D
	.byte	$ef, $00, $00, $00	;3E
	.byte	$ef, $00, $00, $00	;3F

title_name:
	.incbin	"gekioko.nam"

